Index: doc/theses/andrew_beach_MMath/code/ThrowFinally.java
===================================================================
--- doc/theses/andrew_beach_MMath/code/ThrowFinally.java	(revision 04141f8367919cfad1bca5b88ed69f483d585b83)
+++ doc/theses/andrew_beach_MMath/code/ThrowFinally.java	(revision e4da70b388776ac48076cb372eee90f2621120a3)
@@ -7,5 +7,9 @@
 			throws EmptyException {
 		if (0 < frames) {
-			unwind_finally(frames - 1);
+			try {
+				unwind_finally(frames - 1);
+			} finally {
+				// ...
+			}
 		} else {
 			throw new EmptyException();
Index: doc/theses/andrew_beach_MMath/code/ThrowOther.java
===================================================================
--- doc/theses/andrew_beach_MMath/code/ThrowOther.java	(revision 04141f8367919cfad1bca5b88ed69f483d585b83)
+++ doc/theses/andrew_beach_MMath/code/ThrowOther.java	(revision e4da70b388776ac48076cb372eee90f2621120a3)
@@ -16,8 +16,7 @@
 				// ...
 			}
+		} else if (should_throw) {
+			throw new NotRaisedException();
 		} else {
-			if (should_throw) {
-				throw new NotRaisedException();
-			}
 			throw new EmptyException();
 		}
Index: doc/theses/andrew_beach_MMath/code/run.sh
===================================================================
--- doc/theses/andrew_beach_MMath/code/run.sh	(revision e4da70b388776ac48076cb372eee90f2621120a3)
+++ doc/theses/andrew_beach_MMath/code/run.sh	(revision e4da70b388776ac48076cb372eee90f2621120a3)
@@ -0,0 +1,33 @@
+#!/usr/bin/env bash
+
+readonly ALL_TESTS=(cond-match-{all,none} cross-{catch,finally} \
+		raise-{detor,empty,finally,other})
+
+gen-file-name() (
+	if echo "$1" | grep -q -E '^[^%]*%[^%]*$' -; then
+		for L in {a..z}; do
+			file_name=${1//%/$L}
+			if ! [ -e $file_name ]; then
+				break
+			fi
+		done
+		echo $file_name
+	else
+		echo "$1"
+	fi
+)
+
+readonly N=${1:-5}
+readonly OUT_FILE=$(gen-file-name ${2:-run-%-$N})
+
+run-tests() (
+	for ((i = 0 ; i < N ; ++i)); do
+		for test in ${ALL_TESTS[@]}; do
+			for lang in cfa-t cfa-r cpp java python; do
+				./test.sh $lang $test
+			done
+		done
+	done
+)
+
+run-tests > $OUT_FILE
